class Router:
    '''
    Base Router class
    -----------------
    All routers are callable objects
    '''
    def __init__(self, node, **kwargs):
        self.env = node.env
        self.node = node

    def __call__(self, packet):
        raise NotImplementedError

    def on_send_success(self, packet, target):
        pass

    def on_send_failure(self, packet, target):
        pass
